# CfnDevEndpoint

The `AWS::Glue::DevEndpoint` resource specifies a development endpoint where a developer can remotely debug ETL scripts for AWS Glue .

For more information, see [DevEndpoint Structure](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-api-jobs-dev-endpoint.html#aws-glue-api-jobs-dev-endpoint-DevEndpoint) in the AWS Glue Developer Guide.

Extends: [Construct](https://docs.aws.amazon.com/cdk/api/v2/docs/constructs.Construct.html) › [CfnElement](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnElement.html) › [CfnRefElement](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnRefElement.html) › [CfnResource](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.CfnResource.html) › CfnDevEndpoint
Implements: [IInspectable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.IInspectable.html), [ITaggable](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.ITaggable.html), [IEnvironmentAware](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.IEnvironmentAware.html), [IDevEndpointRef](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_glue.IDevEndpointRef.html), IConstruct, IDependable

- CloudFormation: [`AWS::Glue::DevEndpoint`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-glue-devendpoint.html)
- Source: Generated at build time
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

TypeScript:

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_glue as glue } from 'aws-cdk-lib';

declare const arguments_: any;
declare const tags: any;
const cfnDevEndpoint = new glue.CfnDevEndpoint(this, 'MyCfnDevEndpoint', {
  roleArn: 'roleArn',

  // the properties below are optional
  arguments: arguments_,
  endpointName: 'endpointName',
  extraJarsS3Path: 'extraJarsS3Path',
  extraPythonLibsS3Path: 'extraPythonLibsS3Path',
  glueVersion: 'glueVersion',
  numberOfNodes: 123,
  numberOfWorkers: 123,
  publicKey: 'publicKey',
  publicKeys: ['publicKeys'],
  securityConfiguration: 'securityConfiguration',
  securityGroupIds: ['securityGroupIds'],
  subnetId: 'subnetId',
  tags: tags,
  workerType: 'workerType',
});
```

Python:

```python
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_glue as glue

# arguments_: Any
# tags: Any

cfn_dev_endpoint = glue.CfnDevEndpoint(self, "MyCfnDevEndpoint",
    role_arn="roleArn",

    # the properties below are optional
    arguments=arguments_,
    endpoint_name="endpointName",
    extra_jars_s3_path="extraJarsS3Path",
    extra_python_libs_s3_path="extraPythonLibsS3Path",
    glue_version="glueVersion",
    number_of_nodes=123,
    number_of_workers=123,
    public_key="publicKey",
    public_keys=["publicKeys"],
    security_configuration="securityConfiguration",
    security_group_ids=["securityGroupIds"],
    subnet_id="subnetId",
    tags=tags,
    worker_type="workerType"
)
```

Java:

```java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.glue.*;

Object arguments_;
Object tags;

CfnDevEndpoint cfnDevEndpoint = CfnDevEndpoint.Builder.create(this, "MyCfnDevEndpoint")
        .roleArn("roleArn")

        // the properties below are optional
        .arguments(arguments_)
        .endpointName("endpointName")
        .extraJarsS3Path("extraJarsS3Path")
        .extraPythonLibsS3Path("extraPythonLibsS3Path")
        .glueVersion("glueVersion")
        .numberOfNodes(123)
        .numberOfWorkers(123)
        .publicKey("publicKey")
        .publicKeys(List.of("publicKeys"))
        .securityConfiguration("securityConfiguration")
        .securityGroupIds(List.of("securityGroupIds"))
        .subnetId("subnetId")
        .tags(tags)
        .workerType("workerType")
        .build();
```

C# / .NET:

```csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.Glue;

var arguments_;
var tags;

var cfnDevEndpoint = new CfnDevEndpoint(this, "MyCfnDevEndpoint", new CfnDevEndpointProps {
    RoleArn = "roleArn",

    // the properties below are optional
    Arguments = arguments_,
    EndpointName = "endpointName",
    ExtraJarsS3Path = "extraJarsS3Path",
    ExtraPythonLibsS3Path = "extraPythonLibsS3Path",
    GlueVersion = "glueVersion",
    NumberOfNodes = 123,
    NumberOfWorkers = 123,
    PublicKey = "publicKey",
    PublicKeys = new [] { "publicKeys" },
    SecurityConfiguration = "securityConfiguration",
    SecurityGroupIds = new [] { "securityGroupIds" },
    SubnetId = "subnetId",
    Tags = tags,
    WorkerType = "workerType"
});
```

Golang:

```go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

var arguments_ interface{}
var tags interface{}

cfnDevEndpoint := awscdk.Aws_glue.NewCfnDevEndpoint(this, jsii.String("MyCfnDevEndpoint"), &CfnDevEndpointProps{
	RoleArn: jsii.String("roleArn"),

	// the properties below are optional
	Arguments: arguments_,
	EndpointName: jsii.String("endpointName"),
	ExtraJarsS3Path: jsii.String("extraJarsS3Path"),
	ExtraPythonLibsS3Path: jsii.String("extraPythonLibsS3Path"),
	GlueVersion: jsii.String("glueVersion"),
	NumberOfNodes: jsii.Number(123),
	NumberOfWorkers: jsii.Number(123),
	PublicKey: jsii.String("publicKey"),
	PublicKeys: []*string{
		jsii.String("publicKeys"),
	},
	SecurityConfiguration: jsii.String("securityConfiguration"),
	SecurityGroupIds: []*string{
		jsii.String("securityGroupIds"),
	},
	SubnetId: jsii.String("subnetId"),
	Tags: tags,
	WorkerType: jsii.String("workerType"),
})
```

## Initializer

TypeScript:

```ts
new CfnDevEndpoint(scope: Construct, id: string, props: CfnDevEndpointProps)
```

Python:

```python
CfnDevEndpoint(scope: Construct, id: str, props: CfnDevEndpointProps)
```

Java:

```java
new CfnDevEndpoint(Construct scope, String id, CfnDevEndpointProps props)
```

C# / .NET:

```csharp
new CfnDevEndpoint(Construct scope, string id, CfnDevEndpointProps props)
```

Golang:

```go
NewCfnDevEndpoint(Scope Construct, Id *string, Props CfnDevEndpointProps)
```

## Construct Props

- `arguments`: any — A map of arguments used to configure the `DevEndpoint` .

  Valid arguments are:

  - `"--enable-glue-datacatalog": ""`
  - `"GLUE_PYTHON_VERSION": "3"`
  - `"GLUE_PYTHON_VERSION": "2"`

  You can specify a version of Python support for development endpoints by using the `Arguments` parameter in the `CreateDevEndpoint` or `UpdateDevEndpoint` APIs. If no arguments are provided, the version defaults to Python 2.

- `endpointName`: string — The name of the `DevEndpoint` .

- `extraJarsS3Path`: string — The path to one or more Java `.jar` files in an S3 bucket that should be loaded in your `DevEndpoint` .

  > You can only use pure Java/Scala libraries with a `DevEndpoint` .

- `extraPythonLibsS3Path`: string — The paths to one or more Python libraries in an Amazon S3 bucket that should be loaded in your `DevEndpoint` .

  Multiple values must be complete paths separated by a comma.

  > You can only use pure Python libraries with a `DevEndpoint` . Libraries that rely on C extensions, such as the [pandas](https://docs.aws.amazon.com/http://pandas.pydata.org/) Python data analysis library, are not currently supported.

- `glueVersion`: string — The AWS Glue version determines the versions of Apache Spark and Python that AWS Glue supports.

  The Python version indicates the version supported for running your ETL scripts on development endpoints.

  For more information about the available AWS Glue versions and corresponding Spark and Python versions, see [Glue version](https://docs.aws.amazon.com/glue/latest/dg/add-job.html) in the developer guide.

  Development endpoints that are created without specifying a Glue version default to Glue 0.9.

  You can specify a version of Python support for development endpoints by using the `Arguments` parameter in the `CreateDevEndpoint` or `UpdateDevEndpoint` APIs. If no arguments are provided, the version defaults to Python 2.

- `numberOfNodes`: number — The number of AWS Glue Data Processing Units (DPUs) allocated to this `DevEndpoint` .

- `numberOfWorkers`: number — The number of workers of a defined `workerType` that are allocated to the development endpoint.

  The maximum number of workers you can define are 299 for `G.1X` , and 149 for `G.2X` .

- `publicKey`: string — The public key to be used by this `DevEndpoint` for authentication.

  This attribute is provided for backward compatibility because the recommended attribute to use is public keys.

- `publicKeys`: string[] — A list of public keys to be used by the `DevEndpoints` for authentication.

  Using this attribute is preferred over a single public key because the public keys allow you to have a different private key per client.

  > If you previously created an endpoint with a public key, you must remove that key to be able to set a list of public keys. Call the `UpdateDevEndpoint` API operation with the public key content in the `deletePublicKeys` attribute, and the list of new keys in the `addPublicKeys` attribute.

- `roleArn`: string (required) — The Amazon Resource Name (ARN) of the IAM role used in this `DevEndpoint` .

- `securityConfiguration`: string — The name of the `SecurityConfiguration` structure to be used with this `DevEndpoint` .

- `securityGroupIds`: string[] — A list of security group identifiers used in this `DevEndpoint` .

- `subnetId`: string — The subnet ID for this `DevEndpoint` .

- `tags`: any — The tags to use with this DevEndpoint.

- `workerType`: string — The type of predefined worker that is allocated to the development endpoint.

  Accepts a value of Standard, G.1X, or G.2X.

  - For the `Standard` worker type, each worker provides 4 vCPU, 16 GB of memory and a 50GB disk, and 2 executors per worker.
  - For the `G.1X` worker type, each worker maps to 1 DPU (4 vCPU, 16 GB of memory, 64 GB disk), and provides 1 executor per worker. We recommend this worker type for memory-intensive jobs.
  - For the `G.2X` worker type, each worker maps to 2 DPU (8 vCPU, 32 GB of memory, 128 GB disk), and provides 1 executor per worker. We recommend this worker type for memory-intensive jobs.

  Known issue: when a development endpoint is created with the `G.2X` `WorkerType` configuration, the Spark drivers for the development endpoint will run on 4 vCPU, 16 GB of memory, and a 64 GB disk.

## Properties

- `arguments`: any — A map of arguments used to configure the `DevEndpoint` .

- `attrId`: string

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `devEndpointRef`: [DevEndpointReference](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_glue.DevEndpointReference.html) — A reference to a DevEndpoint resource.

- `endpointName`: string — The name of the `DevEndpoint` .

- `env`: [ResourceEnvironment](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `extraJarsS3Path`: string — The path to one or more Java `.jar` files in an S3 bucket that should be loaded in your `DevEndpoint` .

- `extraPythonLibsS3Path`: string — The paths to one or more Python libraries in an Amazon S3 bucket that should be loaded in your `DevEndpoint` .

- `glueVersion`: string — The AWS Glue version determines the versions of Apache Spark and Python that AWS Glue supports.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `node`: [Node](https://docs.aws.amazon.com/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `numberOfNodes`: number — The number of AWS Glue Data Processing Units (DPUs) allocated to this `DevEndpoint` .

- `numberOfWorkers`: number — The number of workers of a defined `workerType` that are allocated to the development endpoint.

- `publicKey`: string — The public key to be used by this `DevEndpoint` for authentication.

- `publicKeys`: string[] — A list of public keys to be used by the `DevEndpoints` for authentication.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `roleArn`: string — The Amazon Resource Name (ARN) of the IAM role used in this `DevEndpoint` .

- `securityConfiguration`: string — The name of the `SecurityConfiguration` structure to be used with this `DevEndpoint` .

- `securityGroupIds`: string[] — A list of security group identifiers used in this `DevEndpoint` .

- `stack`: [Stack](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `subnetId`: string — The subnet ID for this `DevEndpoint` .

- `tags`: [TagManager](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: any — The tags to use with this DevEndpoint.

- `workerType`: string — The type of predefined worker that is allocated to the development endpoint.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnDevEndpoint(x: any): boolean` (static) — Checks whether the given object is a CfnDevEndpoint.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
